@extends('layouts.app')

@section('content')

<h1 class="text-center">Timeline</h1>
<div style="width: 100%; height: 800px" id="svg-container">
</div>
<div style="width: 100%; height: 800px" id="info-container">
</div>

<script src="https://cdnjs.cloudflare.com/ajax/libs/d3/7.1.1/d3.min.js" integrity="sha512-COTaPOlz12cG4fSfcBsxZsjauBAyldqp+8FQUM/dZHm+ts/jR4AFoJhCqxy8K10Jrf3pojfsbq7fAPTb1XaVkg==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

<script type="text/javascript">
    
    var period = @json($period ?? 3600);
    var interval = @json($interval ?? 600);
    var evidences = @json($evidences);
    //console.log(evidences);
    var agents = @json($agents);
    var current_time = Date.now();
    //go through the array of Evidence arrays and create a new array with the data to be displayed
    const timeline_evidences = [];
    for (var i = 0; i < evidences.length; i++) {
        var bin = evidences[i];
        //get the time for this specific bin
        var bin_timestamp = current_time - ((period * 1000) - (interval * i * 1000));
        //loop over the bin and extract all evidences for the given agent and create a new evidence for the timeline
        for (var a = 0; a < agents.length; a++) {
            var filtered_ev = [];
            (bin === null) ? filtered_ev = [] : filtered_ev = bin.filter(ev => ev.label === agents[a].label);
            const timeline_evidence = {"label" : agents[a].label,
                "amount" : filtered_ev.length,
                "evidences" : filtered_ev,
                "time" : bin_timestamp};
            timeline_evidences.push(timeline_evidence);
        }
    }
    //sort the evidences per timestamp
    var sorted_evidences = timeline_evidences.sort((a, b) => (a.time > b.time ? 1 : -1));
    //console.log(sorted_evidences);

    var svg_container = document.getElementById("svg-container");
    var info_container = document.getElementById("info-container");
    LineChart(sorted_evidences,svg_container,info_container,  {
        x: d => d.time,
        y: d => d.amount,
        z: d => d.label,
        ev_data: d => d.evidences,
        yLabel: "Amount",
        width: window.innerWidth,
        height: 800,
        color: "steelblue"
    })


    @include('scripts.line-chart')

</script>

@endsection
